Unit ZF17R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTZF10_p;

procedure ZF17R(FUNCD :Proc_F3; A :Real; B :Real; EPS :Real;
                var ROOT :Real; ITMAX :Integer; var IERR :Integer);

implementation

procedure ZF17R(FUNCD :Proc_F3; A :Real; B :Real; EPS :Real;
                var ROOT :Real; ITMAX :Integer; var IERR :Integer);
var
I :Integer;
FL,DF,XL,XH,SWAP,DXOLD,DX,F,TEMP,FH :Real;
const
ZERO :Real = 0.0;
label
_10,_20,_30,_40,_50,_60,_70,_90,_80;
begin
IERR := 0;
FUNCD(A,FL,DF);
FUNCD(B,FH,DF);
if ( FL*FH < ZERO ) 
 then goto _10;
IERR := 66;
goto _90;
_10:
if ( FL >= ZERO ) 
 then goto _20;
XL := A;
XH := B;
goto _30;
_20:
XH := A;
XL := B;
SWAP := FL;
FL := FH;
FH := SWAP;
_30:
ROOT := (A+B)/2;
DXOLD := Abs(B-A);
DX := DXOLD;
FUNCD(ROOT,F,DF);
for I:=1 to ITMAX do
 begin
  _ZF17RR.elm1:= I;
  if ( ((ROOT-XH)*DF-F)*((ROOT-XL)*DF-F) >= ZERO
       ) or (       Abs(2*F) > Abs(DXOLD*DF) ) 
   then goto _40;
  DXOLD := DX;
  DX := F/DF;
  TEMP := ROOT;
  ROOT := ROOT-DX;
  if ( TEMP = ROOT ) 
   then goto _80;
  goto _50;
_40:
  DXOLD := DX;
  DX := (XH-XL)/2;
  ROOT := XL+DX;
  if ( XL = ROOT ) 
   then goto _80;
_50:
  if ( Abs(DX) < Abs(EPS) ) 
   then goto _80;
  FUNCD(ROOT,F,DF);
  if ( F < ZERO ) 
   then goto _60;
  XH := ROOT;
  FH := F;
  goto _70;
_60:
  XL := ROOT;
  FL := F;
_70:
 end;
IERR := 65;
_90:
UTZF10(IERR,17);
_80:
end;

end.
